package jp.moja.socklet.util;

import java.util.ArrayList;
import java.util.LinkedList;

import jp.wda.gpss.SocketProcessor;

/**
 * l̃j[NID𐶐ACӂObject֘Atĕۊǂ郆[eBeBNX
 * @author Takenori Adachi(TheCoolMuseum)
 */
public class IdGenerator {
	private ArrayList<Object> idTable;
	private LinkedList<Integer> recycleTable;
	/**
	 * IDۑNCAg
	 */
	private String clientAttributeName;
	private static final String DEFAULT_CLIENT_ATTRIBUTE_NAME = "__ID";

	/**
	 * RXgN^
	 * @param clientAttributeName
	 */
	public IdGenerator(String clientAttributeName) {
		idTable = new ArrayList<Object>();
		idTable.add(null);
		recycleTable = new LinkedList<Integer>(); 
		this.clientAttributeName = clientAttributeName;
	}
	/**
	 * RXgN^
	 */
	public IdGenerator(){
		this(DEFAULT_CLIENT_ATTRIBUTE_NAME);
	}

	/**
	 * IuWFNgXgɓo^AID擾
	 * @param obj
	 * @return
	 */
	public synchronized int enter(Object obj) {
		int num=0;
		if(recycleTable.size()>0){
			num = recycleTable.removeFirst();
			idTable.set(num, obj);
		}else{
			num = idTable.size();
			idTable.add(obj);
		}
		return num;
	}

	public synchronized int enter(SocketProcessor client) {
		int id = enter((Object)client);
		client.setAttribute(clientAttributeName, id);
		return id;
	}

	/**
	 * IuWFNgw肵āAIuWFNgo^AIDԋp
	 * @param obj
	 * @return
	 */
	public synchronized boolean exit(Object obj) {
		int id = idTable.indexOf(obj);
		if (id == -1) {
			return false;
		} else {
			idTable.set(id, null);
			recycleTable.add(id);
			//reduce();
			return true;
		}
	}

	/**
	 * IDw肵āAIuWFNgo^AIDԋp
	 * @param obj
	 * @return
	 */
	public synchronized boolean exit(int id) {
		if (id > idTable.size() - 1) {
			return false;
		} else {
			idTable.set(id, null);
			recycleTable.add(id);
			//reduce();
			return true;
		}
	}

	public synchronized boolean exit(SocketProcessor client) {
		client.removeAttribute(clientAttributeName);
		return exit((Object)client);
	}

	/**
	 * idTablek
	 */
	private void reduce() {
		int id = idTable.size() - 1;
		while (id > 0) {
			if (idTable.get(id) == null) {
				idTable.remove(id);

			} else {
				break;
			}
			id--;
		}
	}

	/**
	 * IuWFNgAIDԂ
	 * @param obj
	 * @return
	 */
	public int getId(Object obj) {
		return idTable.indexOf(obj);
	}

	/**
	 * w肳ꂽID̃IuWFNgԂ
	 * @param id
	 * @return
	 */
	public Object getObject(int id) {
		return idTable.get(id);
	}
	
	/**
	 * IDۑNCAg擾܂
	 * @return
	 */
	public String getClientAttributeName(){
		return clientAttributeName;
	}
	
	/**
	 * IDۑNCAgݒ肵܂
	 * @param attributeName
	 * @return 
	 */
	public void setClientAttributeName(String attributeName){
		this.clientAttributeName = attributeName;
	}

}
